﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Buzz.MachineInterface;

namespace WDE.Freezer2
{

    public class SampleData
    {
        private float [] sampleData;        
        private int defaultSize = 44100 * 10 * 2; // 10 seconds 

        public SampleData()
        {
            sampleData = new float[defaultSize];
        }

        public float [] GetBuffer()
        {
            return sampleData;
        }

        public void AddSample(Sample sample, int pos)
        {            
            if (pos*2 >= sampleData.Length)
            {
                Array.Resize(ref sampleData, pos*2 + defaultSize);
            }

            sampleData[pos * 2] = sample.L;
            sampleData[pos * 2+1] = sample.R;            
        }

        public Sample GetSample(int pos)
        {            
            Sample sample = new Sample(0.0f);
            if (pos*2+1 < sampleData.Length)
            {
                sample.L = sampleData[pos * 2];
                sample.R = sampleData[pos * 2 + 1];
            }
            return sample;
        }

        internal void GetSampleBuf(ref Sample[] output, int numsamples, int playPosition)
        {
            for (int i = 0; i < numsamples; i++)
            {
                output[i] = this.GetSample(playPosition + i);
            }
        }

        internal void AddSampleBuf(Sample[] input, int numsamples, int playPosition)
        {
            for (int i = 0; i < numsamples; i++)
            {
                this.AddSample(input[i], playPosition + i);
            }

        }

        public void ZeroBuffers()
        {
            for (int i = 0; i < sampleData.Length; i++)
            {
                sampleData[i] = 0.0f;
            }
        }

        //public int Length { get {return sampleData.Length;} set; }
    }
}
